/*
 * $Id: share_hash.h,v 1.5 2003/03/06 02:31:59 jasta Exp $
 *
 * Copyright (C) 2001-2003 giFT project (gift.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

#ifndef __SHARE_HASH_H
#define __SHARE_HASH_H

/*****************************************************************************/

/**
 * @file share_hash.h
 *
 * @todo Doxygen
 */

/*****************************************************************************/

typedef unsigned char* (*HashAlgorithm) (char *path, char *type, int *len);
typedef char* (*HashHuman) (unsigned char *hash, int *len);

typedef struct
{
	unsigned char *hash;
	int            len;
	char          *type;
} ShareHash;

typedef struct
{
	char          *type;
	HashAlgorithm  algo;
	HashHuman      human;
	Dataset       *ref;
} ShareHashType;

/*****************************************************************************/

int hash_algo_register (struct _protocol *p, char *type,
                        HashAlgorithm algo, HashHuman human);
void hash_algo_unregister (struct _protocol *p, char *type);
int hash_algo_run (struct _file_share *file);
ShareHashType *hash_algo_lookup (char *type);

ShareHash *share_hash_new (unsigned char *hash, int len, char *hash_type);
ShareHash *share_hash_dup (ShareHash *sh);
void share_hash_free (ShareHash *sh);

ShareHash *share_hash_get (struct _file_share *file, char *hash_type);
int share_hash_set (struct _file_share *file, char *hash_type,
                    unsigned char *hash, int len);
char *share_hash_human (struct _file_share *file, char *hash_type, int *rlen);
void share_hash_clear (struct _file_share *file);
void share_hash_foreach (struct _file_share *file, DatasetForeach func,
                         void *udata);

/*****************************************************************************/

char      *hash_algo   (char *hash);
char      *hash_data   (char *hash);

/*****************************************************************************/

#endif /* __SHARE_HASH_H */
